function OperatorService(OperatorRepository, Query, OperatorValidateSupervisor, FiliaisLogin, ValidateConsumerPass,
						 CaixasLogin, VendedoresLogin, TrocaModoCaixa, FindTefSSLConnectionId, auth,
						 UpdateVersionRepository, FindPendingPayments, ParamsMenuRepository) {

	this.AtualizarPrecoProdutoAtual = function(){
		if (!window.location.href.endsWith('/menu')) return;
		OperatorRepository.findOne().then(function(operatorData){
			ParamsMenuRepository.download(Query.build().where('chave').equals(operatorData.chave))
			.then(function(produtosData){
				var popupDetalhesProduto = ApplicationContext.templateManager
					.containers.menu.widgets[1].widgets[1].widgets[0];
				var infoProdutoAtualmenteExibido = produtosData.ParamsMenuRepository.find(
					function(produto){
						return produto.CDPRODUTO === popupDetalhesProduto.currentRow.CDPRODUTO;
					}
				);
				popupDetalhesProduto.currentRow.PRECO = infoProdutoAtualmenteExibido.PRECO;
				popupDetalhesProduto.reload();
			});
		});
	};

	this.login = function(filial, caixa, operador, senha, version, currentMode){

		var query = Query.build()
			.where("filial")
			.equals(filial)
			.where("caixa")
			.equals(caixa)
			.where("operador")
			.equals(operador)
			.where("senha")
			.equals(senha)
			.where("version")
			.equals(version)
			.where("currentMode")
			.equals(currentMode);
		return OperatorRepository.download(query);
	};

	this.getFiliaisLogin = function(filialField) {
		var query = Query.build();
		return FiliaisLogin.downloadSome(query, 1, filialField.itemsPerPage);
	};

	this.getCaixasLogin = function(filial, caixasField) {
		var query = Query.build()
			.where("CDFILIAL")
			.equals(filial);
		return CaixasLogin.downloadSome(query, 1, caixasField.itemsPerPage);
	};

	this.getVendedoresLogin = function(filial, vendedoresField) {
		var query = Query.build()
			.where("CDFILIAL")
			.equals(filial);
		return VendedoresLogin.downloadSome(query, 1, vendedoresField.itemsPerPage);
	};

	this.validateSupervisor = function(supervisor, senha, accessParam, accessMode) {
		var query = Query.build()
			.where("supervisor").equals(supervisor)
			.where("senha").equals(senha)
			.where("accessParam").equals(accessParam)
            .where("accessMode").equals(accessMode);
		return OperatorValidateSupervisor.download(query);
	};

	this.validateConsumerPass = function(CDCLIENTE, CDCONSUMIDOR, senha) {
		var query = Query.build()
			.where("CDCLIENTE")
			.equals(CDCLIENTE)
			.where("CDCONSUMIDOR")
			.equals(CDCONSUMIDOR)
			.where("senha")
			.equals(senha);
		return ValidateConsumerPass.download(query);
	};

	this.trocaModoCaixa = function(chaveSessao, currentMode) {
		var query = Query.build()
			.where("currentMode")
			.equals(currentMode)
			.where("chaveSessao")
			.equals(chaveSessao);
		return TrocaModoCaixa.download(query);
	};

	this.buscaTefSSLConnectionId = function(IDSERIALDISP) {
		var query = Query.build()
			.where("IDSERIALDISP")
			.equals(IDSERIALDISP);
		return FindTefSSLConnectionId.download(query);
	};

	this.auth = function(email, senha, version) {
		var query = Query.build()
			.where("email").equals(email)
			.where("senha").equals(senha)
			.where("version").equals(version);
		return auth.download(query);
	};

	this.updateVersion = function(frontVersion){
		var query = Query.build()
			.where("frontVersion").equals(frontVersion);
		return UpdateVersionRepository.download(query);
	};

	this.findPendingPayments = function() {
		var query = Query.build();
		return FindPendingPayments.download(query);
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register("OperatorService", OperatorService);
});
